import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringReader;
import java.io.StringWriter;
import java.util.Hashtable;

import javax.servlet.ServletException;
import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.enhydra.zeus.Marshaller;
import org.enhydra.zeus.Unmarshaller;
import org.enhydra.zeus.result.StreamResult;
import org.enhydra.zeus.source.StreamSource;

import dataObj.Resp_info;
import dataObj.Resp_infoImpl;
import dataObj.Send_info;

/**
 * @author administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class SendXml_wait20 extends HttpServlet {
	private String _xmlParam;
	private Object _paramObj;
	private HttpServletRequest _request;
	private HttpServletResponse _response;
	private static Hashtable _itemTable = new Hashtable();
	private WaitTimer _timer;
	
	private static final int WAIT_MSEC = 10000;		// T[o[x~b
	
	// iXg: Ƃ肠code=1`3
	static {
		_itemTable.put(new Integer(1), new Item(1, 100, "Item_1"));
		_itemTable.put(new Integer(2), new Item(2, 200, "Item_2"));
		_itemTable.put(new Integer(3), new Item(3, 100, "Item_3"));
	}	
	
	
	public void init() {
		_timer = new WaitTimer(WAIT_MSEC);
	}

	public void doPost(HttpServletRequest request,
	                  HttpServletResponse response) throws IOException, ServletException
	{
		_request = request;
		_response = response;
		
		// xmlbZ[WIuWFNgɕϊ
		getXmlParam();
		// unmarshal
		StreamSource source = new StreamSource(new StringReader(_xmlParam));
		Unmarshaller unmarshaller = new Unmarshaller();
		unmarshaller.setJavaPackage("dataObj");
		_paramObj =  unmarshaller.unmarshal(source).getObject();
		// unmarshaler̖߂lۂ̃f[^ێNXփLXg
		Send_info _info = (Send_info)_paramObj;
		// i: Lŕ
		Item item = (Item)_itemTable.get(new Integer(_info.getItemCD()));
		Resp_info respInfo = new Resp_infoImpl();
			respInfo.setResultFlg("");
			respInfo.setRespMsg("");
			respInfo.setSendID("");
			respInfo.setName("");
			respInfo.setUnitPrice(0);
			respInfo.setQuantity(0);
			respInfo.setSumTotal(0);
			respInfo.setItemCD(0);
			respInfo.setItemName("");
		if (item != null) {
			respInfo.setResultFlg("OK");
			respInfo.setRespMsg("mitukatta");
			respInfo.setSendID(_info.getSendID());
			respInfo.setName(_info.getName());
			respInfo.setUnitPrice(item._unitPrice);
			respInfo.setQuantity(_info.getQuantity());
			respInfo.setSumTotal(respInfo.getQuantity() * respInfo.getUnitPrice());
			respInfo.setItemCD(_info.getItemCD());
			respInfo.setItemName(item._itemName);
		}	else {
			respInfo.setResultFlg("NG");
			respInfo.setRespMsg("mitukaran");
			respInfo.setSendID(_info.getSendID());
			respInfo.setName(_info.getName());
			// respInfo.setUnitPrice();
			respInfo.setQuantity(_info.getQuantity());
			// respInfo.setSumTotal(respInfo.getQuantity() * respInfo.getUnitPrice());
		}
		
		// marshalerŉXML𐶐
		StringWriter strWriter = new StringWriter();
		StreamResult result = new StreamResult(strWriter);
		Marshaller marshaller = new Marshaller();
		marshaller.marshal(respInfo, result);
		// wb_, 󔒕񓙂trimming
		String sendStr = trimXml(strWriter.getBuffer().toString());
System.out.println(sendStr);	// for debug
		// o
		_response.setContentType("text/xml; charset=UTF-8"); 
		PrintWriter prtWriter = _response.getWriter();
		waiting_resp();		// Ŏԑ҂
System.out.println("Timeup");
		prtWriter.write(sendStr);
	}
	
	private void waiting_resp () {
		_timer.start();
		_timer.join();
	}

	private String trimXml(String xml) throws IOException {
		StringReader reader = new StringReader(xml);
		BufferedReader bufReader = new BufferedReader(reader);
		StringBuffer buffer = new StringBuffer();
		String line;
		while ((line = bufReader.readLine()) != null) {
			if (line.indexOf("<?xml") == -1) {
				buffer.append(line);
			}
		}
		return buffer.toString();
	}
	
  private void getXmlParam()  {
    try {
      int len = _request.getContentLength();

      //  getParameter()ŎꍇH
      if (len < 0)
        return ;

      ServletInputStream strm = _request.getInputStream();
      byte[] buf = new byte[len];
      int res = strm.read(buf, 0, len);

      _xmlParam = new String(buf, 0, res, "UTF-8");

System.out.println(_xmlParam);

    } catch (IOException ex) {
    	ex.printStackTrace();
    }
  }
}
