
/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at &lt;http://zeus.enhydra.org&gt;
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
		
package dataObj ;
		
// Global Implementation Import Statements
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import org.xml.sax.Attributes;
import org.xml.sax.EntityResolver;
import org.xml.sax.ErrorHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

// Local Implementation Import Statements
import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;
		
public class Send_infoImpl extends DefaultHandler implements Unmarshallable, Send_info {
	
	private String _sendID;
	private boolean zeus_sendIDSet;
	
	private String _name;
	private boolean zeus_nameSet;
	
	private int _itemCD;
	private boolean zeus_itemCDSet;
	
	private int _quantity;
	private boolean zeus_quantitySet;
	
	/** The current node in unmarshalling */
	private Unmarshallable zeus_currentUNode;

	/** The parent node in unmarshalling */
	private Unmarshallable zeus_parentUNode;

	/** Whether this node has been handled */
	private boolean zeus_thisNodeHandled = false;

	/** The EntityResolver for SAX parsing to use */
	private static EntityResolver entityResolver;

	/** The ErrorHandler for SAX parsing to use */
	private static ErrorHandler errorHandler;
		

	public Send_infoImpl() {
			
		zeus_sendIDSet = false;
	
		zeus_nameSet = false;
	
		zeus_itemCDSet = false;
	
		zeus_quantitySet = false;
	
	}
	
	public String getSendID() {
		return _sendID ;
	}
	public void setSendID(String sendID) {
		_sendID = sendID;
		zeus_sendIDSet = true;
	}
	
	public String getName() {
		return _name ;
	}
	public void setName(String name) {
		_name = name;
		zeus_nameSet = true;
	}
	
	public int getItemCD() {
		return _itemCD ;
	}
	public void setItemCD(int itemCD) {
		_itemCD = itemCD;
		zeus_itemCDSet = true;
	}
	
	public int getQuantity() {
		return _quantity ;
	}
	public void setQuantity(int quantity) {
		_quantity = quantity;
		zeus_quantitySet = true;
	}
	
    /**
     * &lt;p&gt;
     *  This sets a SAX &lt;code&gt;EntityResolver&lt;/code&gt; for this unmarshalling process.
     * &lt;/p&gt;
     *
     * @param resolver the entity resolver to use.
     */
    public static void setEntityResolver(EntityResolver resolver) {
        entityResolver = resolver;
    }

    /**
     * &lt;p&gt;
     *  This sets a SAX &lt;code&gt;ErrorHandler&lt;/code&gt; for this unmarshalling process.
     * &lt;/p&gt;
     *
     * @param handler the entity resolver to use.
     */
    public static void setErrorHandler(ErrorHandler handler) {
        errorHandler = handler;
    }

		

    public static Send_info unmarshal(File file) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file));
    }

    public static Send_info unmarshal(File file, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file), validate);
    }

    public static Send_info unmarshal(InputStream inputStream) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream));
    }

    public static Send_info unmarshal(InputStream inputStream, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream), validate);
    }

    public static Send_info unmarshal(Reader reader) throws IOException {
        // Delegate with default validation value
        return unmarshal(reader, false);
    }

    public static Send_info unmarshal(Reader reader, boolean validate) throws IOException {
        Send_infoImpl send_info = new Send_infoImpl();
        send_info.setCurrentUNode(send_info);
        send_info.setParentUNode(null);
        // Load the XML parser
        XMLReader parser = null;
        
System.out.println("Unmarshaller");
        String parserClass = System.getProperty("org.xml.sax.driver",
            "org.apache.xerces.parsers.SAXParser");
        try {
            parser = XMLReaderFactory.createXMLReader(parserClass);

            // Set entity resolver, if needed
            if (entityResolver != null) {
                parser.setEntityResolver(entityResolver);
            }

            // Set error handler, if needed
            if (errorHandler != null) {
                parser.setErrorHandler(errorHandler);
            }

            // Register content handler
            parser.setContentHandler(send_info);
        } catch (SAXException e) {
            throw new IOException("Could not load XML parser: " + 
                e.getMessage());
        }

        InputSource inputSource = new InputSource(reader);
        try {
            parser.setFeature("http://xml.org/sax/features/validation", new Boolean(validate).booleanValue());
            parser.parse(inputSource);
        } catch (SAXException e) {
            throw new IOException("Error parsing XML document: " + 
                e.getMessage());
        }

        // Return the resultant object
        return send_info;
    }

    public Unmarshallable getParentUNode() {
        return zeus_parentUNode;
    }

    public void setParentUNode(Unmarshallable parentUNode) {
        this.zeus_parentUNode = parentUNode;
    }

    public Unmarshallable getCurrentUNode() {
        return zeus_currentUNode;
    }

    public void setCurrentUNode(Unmarshallable currentUNode) {
        this.zeus_currentUNode = currentUNode;
    }
	}