
/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at &lt;http://zeus.enhydra.org&gt;
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
		
package dataObj ;
		
// Global Implementation Import Statements
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import org.xml.sax.Attributes;
import org.xml.sax.EntityResolver;
import org.xml.sax.ErrorHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

// Local Implementation Import Statements
import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;
		
public class Push_infoImpl extends DefaultHandler implements Unmarshallable, Push_info {
	
	private double _offer;
	private boolean zeus_offerSet;
	
	private double _bid;
	private boolean zeus_bidSet;
	
	private String _status;
	private boolean zeus_statusSet;
	
	/** The current node in unmarshalling */
	private Unmarshallable zeus_currentUNode;

	/** The parent node in unmarshalling */
	private Unmarshallable zeus_parentUNode;

	/** Whether this node has been handled */
	private boolean zeus_thisNodeHandled = false;

	/** The EntityResolver for SAX parsing to use */
	private static EntityResolver entityResolver;

	/** The ErrorHandler for SAX parsing to use */
	private static ErrorHandler errorHandler;
		

	public Push_infoImpl() {
			
		zeus_offerSet = false;
	
		zeus_bidSet = false;
	
		zeus_statusSet = false;
	
	}
	
	public double getOffer() {
		return _offer ;
	}
	public void setOffer(double offer) {
		_offer = offer;
		zeus_offerSet = true;
	}
	
	public double getBid() {
		return _bid ;
	}
	public void setBid(double bid) {
		_bid = bid;
		zeus_bidSet = true;
	}
	
	public String getStatus() {
		return _status ;
	}
	public void setStatus(String status) {
		_status = status;
		zeus_statusSet = true;
	}
	
    /**
     * &lt;p&gt;
     *  This sets a SAX &lt;code&gt;EntityResolver&lt;/code&gt; for this unmarshalling process.
     * &lt;/p&gt;
     *
     * @param resolver the entity resolver to use.
     */
    public static void setEntityResolver(EntityResolver resolver) {
        entityResolver = resolver;
    }

    /**
     * &lt;p&gt;
     *  This sets a SAX &lt;code&gt;ErrorHandler&lt;/code&gt; for this unmarshalling process.
     * &lt;/p&gt;
     *
     * @param handler the entity resolver to use.
     */
    public static void setErrorHandler(ErrorHandler handler) {
        errorHandler = handler;
    }

		

    public static Push_info unmarshal(File file) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file));
    }

    public static Push_info unmarshal(File file, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file), validate);
    }

    public static Push_info unmarshal(InputStream inputStream) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream));
    }

    public static Push_info unmarshal(InputStream inputStream, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream), validate);
    }

    public static Push_info unmarshal(Reader reader) throws IOException {
        // Delegate with default validation value
        return unmarshal(reader, false);
    }

    public static Push_info unmarshal(Reader reader, boolean validate) throws IOException {
        Push_infoImpl push_info = new Push_infoImpl();
        push_info.setCurrentUNode(push_info);
        push_info.setParentUNode(null);
        // Load the XML parser
        XMLReader parser = null;
        String parserClass = System.getProperty("org.xml.sax.driver",
            "org.apache.xerces.parsers.SAXParser");
        try {
            parser = XMLReaderFactory.createXMLReader(parserClass);

            // Set entity resolver, if needed
            if (entityResolver != null) {
                parser.setEntityResolver(entityResolver);
            }

            // Set error handler, if needed
            if (errorHandler != null) {
                parser.setErrorHandler(errorHandler);
            }

            // Register content handler
            parser.setContentHandler(push_info);
        } catch (SAXException e) {
            throw new IOException("Could not load XML parser: " + 
                e.getMessage());
        }

        InputSource inputSource = new InputSource(reader);
        try {
            parser.setFeature("http://xml.org/sax/features/validation", new Boolean(validate).booleanValue());
            parser.parse(inputSource);
        } catch (SAXException e) {
            throw new IOException("Error parsing XML document: " + 
                e.getMessage());
        }

        // Return the resultant object
        return push_info;
    }

    public Unmarshallable getParentUNode() {
        return zeus_parentUNode;
    }

    public void setParentUNode(Unmarshallable parentUNode) {
        this.zeus_parentUNode = parentUNode;
    }

    public Unmarshallable getCurrentUNode() {
        return zeus_currentUNode;
    }

    public void setCurrentUNode(Unmarshallable currentUNode) {
        this.zeus_currentUNode = currentUNode;
    }
	}